TAAS - Feature #192

Ledger History
05/09/2023 07:08 PM - Junaid M

Status: Reopen Bugs Testing Done Start date: 05/12/2023
Priority: Normal Due date:

Assignee: Augustin Jose % Done: 90%
Category: Estimated time: 0:00 hour
Target version: 22.12 Spent time: 0:00 hour
Owner(Agency): Travvise Tested By:

Time Taken(HH): Code Reviewed By:

Module: Ledger History

Description

Coding Ledger History

History

#1 - 05/11/2023 04:48 PM - Junaid M
- Tracker changed from Bug to Feature

- Assignee changed from Junaid M to Amal Pious

#2 - 05/12/2023 03:08 PM - Amal Pious

- Status changed from New to Coding Started

- Start date changed from 05/09/2023 to 05/12/2023
- % Done changed from 0 to 40

#3 - 05/12/2023 06:20 PM - Amal Pious
- Status changed from Coding Started to New
- % Done changed from 40 to 0

GUI Done

ISSUE FOUNDED

1.CORRECT ALLIGMENT OF BRANCH FIELD
2.CORRECT GRID FILTER FIELDS WHILE EXPANDING
3.ADD ERASE OPTION

#4 - 05/24/2023 04:37 PM - Junaid M

- Assignee changed from Amal Pious to Junaid M

#5 - 06/26/2023 05:27 PM - Anil KV

- Assignee changed from Junaid M to travvise Admin

#6 - 07/15/2024 12:21 PM - Anil KV

—>Currency Selectbox items
—All Currency Code

—-Basel (Currency Code)
—-Base2 (Currency Code)

***Loading and Work flow checking +Ledger Statement+

—>Delete Tab to Deleted

—->Action Date fill

—Action From - Transaction Date TO + 1
—Action To - Current Date

—> Add Column Split each tab list - Created Time (after Create By),

ime (After Deleted By)

#7 - 07/16/2024 10:28 AM - Anil KV
Modified Time (After Modified By),

Deleted T
GUI Change:-

—-> Add 'Ref' And Narration Columns after status - all tabs

#8 - 07/29/2024 10:51 AM - Anil KV
- Status changed from New to Ready for Coding
- % Done changed from 0 to 20

Note:- This logic and SQL not full fill, Coding this logic base and commit, I(Anil) will fix all cases

Ref: Document History
SQL:-

SELECT tr.dat_transaction,
tr.vhr_ledg_currency,
tr.dbl_ledg_cur_debit,

tr.dbl_ledg_cur_credit.
tr.dbl_base_cur_debit,

tr.dbl_base_cur_credit,

tr.dbl_cons_cur_debit,
tr.dbl_cons_cur_credit,

NULL AS int_sys_action_log_id,
NULL AS fk_created_user_log_id,
NULL AS dtm_created_log,
NULL AS fk_last_modified_user_log_id,
NULL AS dtm_last_modified_log,
NULL AS fk_deleted_user_log_id,
NULL AS dtm_deleted_log,

doc.pk_documents_id,
doc.vhr_document_no,
doc.fk_ledger_id,
doc.int_sys_action_id,
doc.fk_created_user_id,
doc.dtm_created,
doc.fk_last_modified_user_id,
doc.dtm_last_modified,
doc.fk_deleted_user_id,
doc.dtm_deleted
FROM transaction.tbl_transaction tr
LEFT JOIN document.tbl_documents doc
ON tr.fk_documents_id = doc.pk_documents_id
WHERE tr.sin_posting_status =1
AND tr.sin_transaction_status = 1
AND tr.sin_document_status = 1
AND tr.fk_ledger_id = 1
AND tr.fk_main_ledger_id = 1
AND tr.fk_branch_id =1
AND tr.fk_department_id =1

UNION ALL

SELECT trlog.dat_transaction,
trlog.vhr_ledg_currency,
trlog.dbl_ledg_cur_debit,

trlog.dbl_ledg_cur_credit.
trlog.dbl_base_cur_debit,

trlog.dbl_base_cur_credit,

trlog.dbl_cons_cur_debit,
trlog.dbl_cons_cur_credit,

doclog.int_sys_action_id AS int_sys_action_log_id,

doclog.fk_created_user_id AS fk_created_user_log_id,

doclog.dtm_created AS dtm_created_log,

doclog.fk_last_modified_user_id AS fk_last_modified_user

doclog.dtm_last_modified AS dtm_last_modified_log,
doclog.fk_deleted_user_id AS fk_deleted_user_log_id,
doclog.dtm_deleted AS dtm_deleted_log,

doc.pk_documents_id,
doc.vhr_document_no,
doc.fk_ledger_id,
doc.int_sys_action_id,
doc.fk_created_user_id,
doc.dtm_created,
doc.fk_last_modified_user_id,
doc.dtm_last_modified,
doc.fk_deleted_user_id,
doc.dtm_deleted
FROM tbl_transaction trlog
LEFT JOIN tbl_documents_log doclog
ON trlog.fk_documents_log_id
LEFT JOIN document.tbl_documents

= doclog.pk_documents_log_id
doc

ON trlog.fk_documents_id = doc.pk_documents_id

WHERE trlog.sin_posting_status = 1
AND trlog.sin_transaction_status
AND trlog.sin_document_status = 1
AND trlog.fk_ledger_id =1
AND trlog.fk_main_ledger_id = 1
AND trlog.fk_branch_id =1
AND trlog.fk_department_id = 1

Logic

Input Change

datActionDateTo = datActionDateTo Add 1 Day

//datActionDateFrom and datActionDateTo ['01/01/2024 00:00:00'] time part need 0

b1lnOlbObSetedADoc = False
blnMainDocumentRecordIn = True
blnMainDocumentRecord = False
blnLastLogRecord = False

binPrvDocumentId = 0
binPrvDocumentLogId = 0
dblPrevTransactionAmount = 0.00
dblOldBalance = 0.00

strTab = "'

lstEachLedgerHistoryData = []
For loop Database Record
// Create Model
// Fill the record to Modele

blnMainDocumentRecord = False
blnLastLogRecord = False

if binPrvDocumentId != binDocumentId
blnOlbObSetedADoc = False
dblPrevTransactionAmount = 0

// Set Prv Document
if lstEachLedgerHistoryData.legth > 0
// ReCheck Tab

if binPrvDocumentLogId is NULL/O
strTab = 'LEDGER_CHANGED'
END IF

// Some value Calculation - Previ

// Set Data

if strTab == "NEW"
lstNew = [...lstNew,
else if strTab == "UPDATED"
lstUpdated = [...1lst
END IF

lstEachLedgerHistoryData = []
END IF

strTab = "'
=1

and strTab == 'UPDATED'

ous, Diff

...lstEachLedgerHistoryDatal

Updated, ...lstEachLedgerHistoryData]
if pk_documents_log_id is NULL/O
blnMainDocumentRecord = True
blnMainDocumentRecordIn = True
if int_sys_action_id >= 1 AND dtm_created and datActionDateFrom < dtm_created and dtm
_created < datActionDateTo
strTab = 'NEW'
else if int_sys_action_id > 1 AND dtm_last_modified and datActionDateFrom < dtm_last_modif
ied and dtm_last_modified < datActionDateTo

strTab = 'UPDATED'
if dtm_created and (datActionDateFrom > dtm_created or dtm_created > datActionDateTo)
strTab = 'PERIOD_CHANGED'
END IF
elseif int_sys_action_id == -1 AND dtm_deleted and datActionDateFrom < dtm_deleted and
dtm_deleted < datActionDateTo
strTab = 'DELETED'

else
blnLastLogRecord = True
blnMainDocumentRecordIn = False
strTab = 'LEDGER_CHANGED'
END IF
END IF

// ReCheck Tab
//1f blnMainDocumentRecordIn == False:

//END IF

// Calculate

dblDiffAmount = (debit - credit) - dblPrevTransactionAmount
if int_sys_action_id == -1
dblDiffAmount = (debit - credit)
END IF
if strTab == "NEW"
dblTotalNew +=
else if strTab == "UPDATED"
else if strTab == "PERIOD_CHANGED"
else if strTab == "LEDGER_CHANGED"
else if strTab == "DELETED"
END IF
if pk_documents_log_id and blnOlbObSetedADoc == False

if int_sys_action_id > 1 AND dtm_last_modified and datActionDateFrom < dtm_last_modified
dblOldBalance += (debit - credit)
blnOlbObSetedADoc = True

END IF

ELSE if int_sys_action_id == -1 AND dtm_deleted and datActionDateFrom < dtm_deleted
dblOldBalance += (debit - credit)
blnOlbObSetedADoc = True

END IF

END IF

// Set Record in tmp list
lstEachLedgerHistoryData.Add (Model)

// Set Prv doc id

binPrvDocumentId = binDocumentId
binPrvDocumentLogId = binDocumentLogId
dblPrevTransactionAmount = debit - credit

END LOOP

// Set Last Document Data
if lstEachLedgerHistoryData.legth > 0
// ReCheck Tab

if binPrvDocumentLogId is NULL/0 and strTab == 'UPDATED'
strTab = 'LEDGER_CHANGED'
END IF

// Set Data

if strTab == "NEW"
lstNew = [...lstNew, ...lstEachLedgerHistoryDatal
else if strTab == "UPDATED"
lstUpdated = [...lstUpdated, ...lstEachLedgerHistoryData]
END IF
#9 - 07/31/2024 04:25 PM - Anil KV

- Assignee changed from travvise Admin to Greeshma S

#10 - 08/23/2024 10:46 AM - Anil KV

- Assignee changed from Greeshma S to Baseem Shan

#11 - 10/24/2024 10:52 AM - Anil KV

- Assignee changed from Baseem Shan to Augustin Jose

#12 - 11/14/2024 11:51 AM - Augustin Jose
- Status changed from Ready for Coding to Coding Started
- % Done changed from 20 to 30

#13 - 11/28/2024 03:01 PM - Augustin Jose
- Status changed from Coding Started to Coding Done
- % Done changed from 30 to 60

#14 - 12/18/2024 02:37 PM - Arathy PS
- Status changed from Coding Done to Testing Started

#15 - 12/18/2024 05:45 PM - Arathy PS
- Status changed from Testing Started to Reopen Bugs
- % Done changed from 60 to 50

ISSUE FOUND

1. Not filtering data based on the user field.
2. Print of summary tab not in correct format.

#16 - 12/27/2024 09:46 AM - Augustin Jose
- Status changed from Reopen Bugs to Reopen Bugs Coding Done
- % Done changed from 50 to 70

#17 - 12/30/2024 10:16 AM - Theja Ponon
- Status changed from Reopen Bugs Coding Done to Reopen Bugs Testing Done

- % Done changed from 70 to 90
